
local function colorizePName(pName, pGUID)
    if(pGUID ~= nil) then
      playerClass = GetPlayerInfoByGUID(pGUID)
      if(playerClass == nil) then -- could not acquire playerClass, returning
        return pName;
      end
      playerClass = strupper(playerClass)
      if(playerClass == "DEATHKNIGHT") then
    		pName = "|cFFC41F3B" .. pName .. "|r"
    	end
    	if(playerClass == "WARRIOR") then
    		pName = "|cFFC79C6E" .. pName .. "|r"
    	end
    	if(playerClass == "PALADIN") then
    		pName = "|cFFF58CBA" .. pName .. "|r"
    	end
    	if(playerClass == "HUNTER") then
    		pName = "|cFFABD473" .. pName .. "|r"
    	end
    	if(playerClass == "ROGUE") then
    		pName = "|cFFFFF569" .. pName .. "|r"
    	end
    	if(playerClass == "PRIEST") then
    		pName = "|cFFFFFFFF" .. pName .. "|r"
    	end
    	if(playerClass == "SHAMAN") then
    		pName = "|cFF0070DE" .. pName .. "|r"
    	end
    	if(playerClass == "MAGE") then
    		pName = "|cFF40C7EB" .. pName .. "|r"
    	end
    	if(playerClass == "WARLOCK") then
    		pName = "|cFF8787ED" .. pName .. "|r"
    	end
    	if(playerClass == "MONK") then
    		pName = "|cFF00FF96" .. pName .. "|r"
    	end
    	if(playerClass == "DRUID") then
    		pName = "|cFFFF7D0A" .. pName .. "|r"
    	end
    	if(playerClass == "DEMONHUNTER") then
    		pName = "|cFFA330C9" .. pName .. "|r"
    	end
    else--no guid or pName detected, returning
      return pName;
    end
      return pName;
end

playerWarKills = { }
sortedWarKills = { }

--CREATING GHOST Frame
warKillGhost = CreateFrame("Frame", "warKillGhost", UIParent)
warKillGhost:SetFrameStrata("BACKGROUND")
warKillGhost:SetWidth(10) -- sets the width
warKillGhost:SetHeight(10)  -- sets height
--these lines enable movement via mouse draggins
warKillGhost:SetMovable(true)
warKillGhost:SetUserPlaced(true)
warKillGhost:SetScript("OnDragStart", warKillGhost.StartMoving)
warKillGhost:SetScript("OnDragStop", function (self) warKillGhost:StopMovingOrSizing(); warPlayerKillFrame:SetPoint("CENTER", warKillGhost, "CENTER", 0, 0); end)
warKillGhost:SetPoint("CENTER", UIParent, "CENTER", 0, 0);

--create the frame for the player kill tracker/counter
warPlayerKillFrame = CreateFrame("Frame", "WarPlayerKillsFrame", warKillGhost)
warPlayerKillFrame:SetFrameStrata("MEDIUM")
warPlayerKillFrame:SetWidth(150) -- sets the width
warPlayerKillFrame:SetHeight(20)
warPlayerKillFrame:SetMovable(true)
warPlayerKillFrame:EnableMouse(true)
warPlayerKillFrame:SetUserPlaced(true)
warPlayerKillFrame:RegisterForDrag("LeftButton")
warPlayerKillFrame:SetScript("OnDragStart", function(self)
  warKillGhost:StartMoving();
end)
warPlayerKillFrame:SetScript("OnDragStop", function(self)
  warKillGhost:StopMovingOrSizing();
end)
warPlayerKillFrame:SetPoint("CENTER", warKillGhost, "CENTER", 0, 0)

--create the title text for the frame
warSlainTitleText = warPlayerKillFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warSlainTitleText:SetPoint("CENTER", warPlayerKillFrame, "TOP", 0, -10)
warSlainTitleText:SetText("Slain Enemies")

--create the text for the kill tracker frame
warSlainEnemiesText = warPlayerKillFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warSlainEnemiesText:SetPoint("TOPLEFT", warPlayerKillFrame, "TOPLEFT", 5, -20)
warSlainEnemiesText:SetJustifyV("TOP");
warSlainEnemiesText:SetJustifyH("LEFT");

warClearKillButton = CreateFrame("Button", "WarClearKillButton", warPlayerKillFrame, "UIPanelButtonTemplate")
warClearKillButton:SetSize(warPlayerKillFrame:GetWidth(), 20)
warClearKillButton:SetPoint("CENTER", warPlayerKillFrame, "CENTER", 0, -warPlayerKillFrame:GetHeight()/2)
warClearKillButton:SetFrameStrata("BACKGROUND")
warClearKillButton.text = warClearKillButton:CreateFontString()
warClearKillButton.text:SetPoint("CENTER", warClearKillButton, "CENTER")
warClearKillButton.text:SetFont("Fonts\\FRIZQT__.TTF", 11)
warClearKillButton.text:SetText("CLEAR KILL LOG")
warClearKillButton:Hide();
warClearKillButton:SetScript("OnClick", function(self, button)
    if button == "LeftButton" then
      wipe(playerWarKills)
      wipe(sortedWarKills)
      warPlayerKillFrame:SetWidth(150)
      warPlayerKillFrame:SetHeight(20)
      warSlainEnemiesText:SetText("")
      warPlayerKillFrame:ClearAllPoints();
      warPlayerKillFrame:SetPoint("CENTER", warKillGhost, "CENTER", 0, 0)
      warClearKillButton:Hide();
    end
end)

function sortWarKillTables()
  wipe(sortedWarKills)
  while(table.getn(playerWarKills) ~= 0)do
    highestKill = 0;
    highestIndex = 0;
    for i=1, table.getn(playerWarKills), 1 do
      if(playerWarKills[i]["killAmount"] > highestKill) then
        highestKill = playerWarKills[i]["killAmount"];
        highestIndex = i;
      end
    end
    if(table.getn(sortedWarKills) == 0 or table.getn(sortedWarKills) == nil) then
      sortedWarKills[1] = playerWarKills[highestIndex]
      table.remove(playerWarKills, highestIndex)
    else
      table.insert(sortedWarKills, playerWarKills[highestIndex])
      table.remove(playerWarKills, highestIndex)
    end
  end
  for i=1, table.getn(sortedWarKills), 1 do
    table.insert(playerWarKills, sortedWarKills[i])
  end
end

function setWarKillsText()
  local killList = "";
  if(table.getn(playerWarKills) == nil or table.getn(playerWarKills) == 0 ) then
    if(warClearKillButton:IsShown() == true) then
      warClearKillButton:Hide()
    end
    warSlainEnemiesText:SetText(killList)
    warPlayerKillFrame:SetWidth(150)
    warPlayerKillFrame:SetHeight(20)
  else
    for i=1, table.getn(playerWarKills), 1 do
      if(playerWarKills[i]["killGUID"] ~= nil and playerWarKills[i]["killGUID"] ~= 0) then
        killList = killList .. colorizePName(playerWarKills[i]["killName"],playerWarKills[i]["killGUID"]) .. ": " .. playerWarKills[i]["killAmount"] .."\n"
      else
        killList = killList .. playerWarKills[i]["killName"] .. ": " .. playerWarKills[i]["killAmount"] .."\n"
      end
    end
    warSlainEnemiesText:SetText(killList)
    warPlayerKillFrame:SetWidth(warSlainEnemiesText:GetStringWidth() + abs(150 - warSlainEnemiesText:GetStringWidth() ))
    warPlayerKillFrame:SetHeight(warSlainEnemiesText:GetStringHeight() + 20)

    warPlayerKillFrame:ClearAllPoints();
    warPlayerKillFrame:SetPoint("CENTER", 0, 0 + ((warSlainEnemiesText:GetStringHeight()) / 2) *-1)

    warClearKillButton:SetPoint("CENTER", warPlayerKillFrame, "CENTER", 0, -warPlayerKillFrame:GetHeight()/2 -10)
    if(warClearKillButton:IsShown() == false) then
      warClearKillButton:Show()
    end
  end
end

local function ProcessWarKill(destName, destGUID)
  local entryExists = false
  for i=1, table.getn(playerWarKills), 1 do
      if(playerWarKills[i]["killName"] == destName) then
        entryExists = true;
        if(playerWarKills[i]["killGUID"] ~= destGUID and destGUID ~= nil) then -- if a kill is detected for a player with the same name and a different GUID
          --make that the GUID. Works with color coding names when swapping between hk and kb tracking
          playerWarKills[i]["killGUID"] = destGUID
        end
        playerWarKills[i]["killAmount"] = playerWarKills[i]["killAmount"] + 1;
        sortWarKillTables()
        setWarKillsText()
        break;
      end
  end
  if(entryExists == false) then
    if(table.getn(playerWarKills) == nil or table.getn(playerWarKills) == 0) then
      newKill = {
        ["killName"] = destName,--colorizePName(destName, destGUID),
        ["killAmount"] = 1,
        ["killGUID"] = destGUID,
        ["killTime"] = time()
      }
      playerWarKills[1] = newKill
    else
    newKill = {
      ["killName"] = destName,--colorizePName(destName, destGUID),
      ["killAmount"] = 1,
      ["killGUID"] = destGUID,
      ["killTime"] = time()
    }
    tinsert(playerWarKills, newKill);
  end
    setWarKillsText()
  end
end


local function OnKillUpdates(_, event, ...)

  if(event=="PLAYER_ENTERING_WORLD")then
      setWarKillsText()
      warPlayerKillFrame:ClearAllPoints();
      if(table.getn(playerWarKills) == 0 or table.getn(playerWarKills) == nil) then
        warPlayerKillFrame:SetPoint("CENTER", warKillGhost, "CENTER", 0, 0)
      else
        warPlayerKillFrame:SetPoint("CENTER", 0, 0 + ((warSlainEnemiesText:GetStringHeight()) / 2) *-1)
      end
  end

  if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
   _,warEventType, _, sourceGUID, sourceName, _, _, destGUID, destName, _, _ = CombatLogGetCurrentEventInfo()
    if(warEventType=="PARTY_KILL") then
      local warUnitType = strsplit("-", destGUID)
        if(warTrackKBNames == true) then
          if (warUnitType == "Player" and GetUnitName("player", false) == sourceName)then
            if(strfind(destName, "-") ~= nil) then
              destName = strsub(destName, 1, strfind(destName, "-") - 1)
            end
            ProcessWarKill(destName, destGUID)
          end
        end
    end
  end

  if(event=="CHAT_MSG_COMBAT_HONOR_GAIN") then
    if(warTrackHKNames == true) then
      local honorMsg, _, _ = ...
      _, _, killName = string.find(honorMsg, "(.+) dies, honorable kill")--, honorable kill Rank: (.+) %(Estimated Honor Points: (.+)%)")
      if(killName) then
        ProcessWarKill(killName, nil)
      end
    end
  end
end
warPlayerKillFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
warPlayerKillFrame:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN")
warPlayerKillFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")
warPlayerKillFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
warPlayerKillFrame:SetScript("OnEvent", OnKillUpdates)
