local addOnName = "PvP Tracker"
--stores current number of kills
warKills = 0;
--gets the name of the player
local warPlayerName = GetUnitName("player", false)

local warPvPRankInfo = {
  [1] = {
    ["value"] = 15,
    ["allianceName"] = "Private",
    ["hordeName"] = "Scout",
  },
  [2] = {
    ["value"] = 2000,
    ["allianceName"] = "Corporal",
    ["hordeName"] = "Grunt",
  },
  [3] = {
    ["value"] = 5000,
    ["allianceName"] = "Sergeant",
    ["hordeName"] = "Sergeant",
  },
  [4] = {
    ["value"] = 10000,
    ["allianceName"] = "Master Sergeant",
    ["hordeName"] = "Senior Sergeant",
  },
  [5] = {
    ["value"] = 15000,
    ["allianceName"] = "Sergeant Major",
    ["hordeName"] = "First Sergeant",
  },
  [6] = {
    ["value"] = 20000,
    ["allianceName"] = "Knight",
    ["hordeName"] = "Stone Guard",
  },
  [7] = {
    ["value"] = 25000,
    ["allianceName"] = "Knight-Lieutenant",
    ["hordeName"] = "Blood Guard",
  },
  [8] = {
    ["value"] = 30000,
    ["allianceName"] = "Knight-Captain",
    ["hordeName"] = "Legionnaire",
  },
  [9] = {
    ["value"] = 35000,
    ["allianceName"] = "Knight-Champion",
    ["hordeName"] = "Centurion",
  },
  [10] = {
    ["value"] = 40000,
    ["allianceName"] = "Lieutenant Commander",
    ["hordeName"] = "Champion",
  },
  [11] = {
    ["value"] = 45000,
    ["allianceName"] = "Commander",
    ["hordeName"] = "Lieutenant General",
  },
  [12] = {
    ["value"] = 50000,
    ["allianceName"] = "Marshal",
    ["hordeName"] = "General",
  },
  [13] = {
    ["value"] = 55000,
    ["allianceName"] = "Field Marshal",
    ["hordeName"] = "Warlord",
  },
  [14] = {
    ["value"] = 60000,
    ["allianceName"] = "Grand Marshal",
    ["hordeName"] = "High Warlord",
  },
}
--print(warPvPRankInfo[1]["allianceName"])
--stores the number of killing blows
totalWarKillingBlows = 0

--container for last killing streak
lastWarKills = 0;
--container for highest killing streak
highestWarKills = 0;
--scale size for the WMT frame set
wmtFrameScale = 1;
-- RGB holders for the WarTrackFrame text
warTextR = 1;
warTextG = 1;
warTextB = 1;
--RGBA holders for the WarTrackFrame background
warFrameR = .1;
warFrameG = .1;
warFrameB = .1;
warFrameTransparency = 0.7;
--Gets the player's PvP honor level
--pvpWarRank = UnitHonorLevel("player")
local honorableKills, dishonorableKills, highestRank = GetPVPLifetimeStats()
local currRankName = 0
local currRankNumber = 0
local highestRankName = 0
local warTodayHonor = 0
local warWeekHonor = 0
local warRequiredHonor = 0
local warHonorPercent = 0
local warHonorDecayPercent = 0;
local warDecayRating = 0

--Gets the players total honorable kills
local totalWarKills, totalDishonorKills,_ = GetPVPLifetimeStats();
local lastTotalWarKills, _,_ = GetPVPLifetimeStats();
--Gets the player's faction
local playerFaction = UnitFactionGroup("player");

--two booleans for tracking whether the window is hidden or show in combat or when not in war mode
warHidePvPState = false
warHideCombatState = false
--Boolean for checking whether or not the player is in combat, specifically used for when hide in combat is checked and hide when not in war mode is unchecked
warCombatState = false

--variable for tracking the state in which killing blows will reset: 1 - Death, 2 - Zone change, 3 - Loading Screen
killingBlowResetDeath = false;
killingBlowResetZone = true;
killingBlowResetLoad = true;

warTrackKBNames = false;
warTrackHKNames = true;

--Library that stores button states
warShowStates = {
	["warFrameState"] = true,
	["lockFrameState"] = false,
	["logoState"] = true,
	["warPvPState"] = true,
	["currKillState"] = true,
	["lastKillState"] = true,
	["highestWarKillState"] = true,
	["totalKillState"] = true,
}
killingBlowState = true;
totalDishonorState = true;
warCurrRankState = true;
warFutureRankState = true;
warPlayerKillTracker = true;
--returns the number of items within a 'source' table, TEST FUNCTION
function active_items(source)
	 return table.getn(source);
end

--CREATING GHOST Frame
warTrackGhost = CreateFrame("Frame", "WarGhostFrame", UIParent)
warTrackGhost:SetWidth(208) -- sets the width
warTrackGhost:SetHeight(100)  -- sets height
--these lines enable movement via mouse draggins
warTrackGhost:SetMovable(true)
warTrackGhost:EnableMouse(true)
warTrackGhost:RegisterForDrag("LeftButton")
warTrackGhost:SetUserPlaced(isUserPlaced)
--allows the mouse to be moved by the mouse
warTrackGhost:SetScript("OnDragStart", warTrackGhost.StartMoving)
warTrackGhost:SetScript("OnDragStop", warTrackGhost.StopMovingOrSizing)
warTrackGhost:SetFrameStrata("LOW")
WarGhostFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);

-- Creating the main frame
warTrackFrame = CreateFrame("Frame", "WarModeFrame", warTrackGhost)
warTrackFrame:SetFrameStrata("BACKGROUND")
warTrackFrame:SetWidth(208) -- sets the width
warTrackFrame:SetHeight(100)  -- sets height

--creation of the future rank tracker frame
warFutureRankFrame = CreateFrame("Frame", "WarFutureRankFrame", UIParent)
warFutureRankFrame:SetFrameStrata("BACKGROUND")
warFutureRankFrame:SetWidth(208) -- sets the width
warFutureRankFrame:SetHeight(88) -- sets the height
warFutureRankFrame:SetMovable(true)
warFutureRankFrame:EnableMouse(true)
warFutureRankFrame:SetUserPlaced(isUserPlaced)
warFutureRankFrame:SetPoint("BOTTOM", warTrackFrame, "BOTTOM", 0, -86) -- the y value was -86 before the addition of the killing blow tracker

--CREATE THE FRAME FOR CURRENT PVP RANK TRACKER
warCurrRankFrame = CreateFrame("Frame", "WarCurrRankFrame", UIParent)
warCurrRankFrame:SetFrameStrata("BACKGROUND")
warCurrRankFrame:SetWidth(208) -- sets the width
warCurrRankFrame:SetHeight(35) -- sets the height
warCurrRankFrame:SetMovable(true)
warCurrRankFrame:EnableMouse(true)
warCurrRankFrame:SetUserPlaced(isUserPlaced)

function GetPlayerPvPStatInfo()

  if(UnitPVPRank("player") >= 1) then
   	currRankName, currRankNumber = GetPVPRankInfo(UnitPVPRank("player"), "player")
    _, _, highestRank = GetPVPLifetimeStats()
    highestRankName = GetPVPRankInfo(highestRank)
  else
  	currRankName = "None"
  	currRankNumber = 0

    highestRank = 0
    highestRankName = "None"
  end

end

function CalculateFutureRankInfo()
  --warWeekHonor =
  --_, warTodayHonor = GetPVPSessionStats()
  warTodayHonor = GetPVPSessionStats()
  if(currRankNumber == 0) then
    --set warweekhonor HERE
    if(totalWarKills < 15) then
      warRequiredHonor = totalWarKills  .. " / " .. "15"
    else
      warRequiredHonor = "15"  .. " / " .. "15"
    end
    if(totalWarKills < 15) then
      warHonorPercent = string.format("%.2f",((totalWarKills / 15) * 100))
    else
      warHonorPercent = string.format("%.2f",((15 / 15) * 100))
    end
    warDecayRating = "N/A"
  else
    --post Unranked calculations
    warHonorPercent = string.format("%.2f",(GetPVPRankProgress() * 10000) / 100)
    local unitPlayerRank = UnitPVPRank("player")
    local currentRP = 0
    if(unitPlayerRank >= 6) then
      currentRP = (unitPlayerRank - 5) * 5000 * warHonorPercent / 100
    else
      if(unitPlayerRank == 5) then
        currentRP = 2000 * warHonorPercent / 100
      end
    end
    _, warWeekHonor = GetPVPThisWeekStats();
    local neededRP = warPvPRankInfo[unitPlayerRank - 3]["value"]
    local prevRankRP = 0;
    if(unitPlayerRank > 5) then
      prevRankRP = warPvPRankInfo[unitPlayerRank - 4]["value"]
    end
    warRequiredHonor = currentRP .. " / " .. neededRP
    --warDecayRating = (currentRP + warWeekHonor) - (neededRP * 0.2)
    --warDecayRating = (currentRP * 0.2) -- used until 6/16/20
    warDecayRating = (currentRP + warPvPRankInfo[currRankNumber]["value"]) * 0.2 --used as of 6/16/20. CURRENT TEST
    if(warDecayRating > 2500) then
      warDecayRating = 2500 -- per wowiki, decay rating will never drop you more than 2500 points
    end

    warHonorPercent = string.format("%.2f",(GetPVPRankProgress() * 10000) / 100)

    --if((currentRP - warDecayRating) < prevRankRP) then -- used until 6/16/20
    if(((currentRP + warPvPRankInfo[currRankNumber]["value"]) - warDecayRating) < prevRankRP) then --used as of 6/16/20. CURRENT TEST
      warHonorDecayPercent = string.format("%.2f",((((currentRP - warDecayRating) / prevRankRP) * 100) * -1))
    else
      warHonorDecayPercent = string.format("%.2f",(((currentRP - warDecayRating) / neededRP) * 100)) --Thanks to Syn and Naruke for resucing me
    end

  end
end

function AdjustCurrRankFramePos()
	if(warShowStates.warFrameState == true) then
		warCurrRankFrame:SetPoint("Center", warTrackFrame, "Center", 0, 65)
		warFutureRankFrame:SetPoint("BOTTOM", warTrackFrame, "BOTTOM", 0, -86)
		WarGhostFrame:SetHeight(160);
	else
			if(warFutureRankState == true) then
				warFutureRankFrame:SetPoint("BOTTOM", warCurrRankFrame, "Center", 0, -103);
				warCurrRankFrame:SetPoint("TOP", WarGhostFrame, "TOP", 0, 0)
				WarGhostFrame:SetHeight(100);
			end
		end
	end

--sets whether or not the faction banner is that of the alliance or horde
local warFactBanner = warTrackFrame:CreateTexture(nil,"ARTWORK")
if (playerFaction == "Alliance") then
	warFactBanner:SetTexture("Interface\\Timer\\Alliance-Logo.blp")
else
	warFactBanner:SetTexture("Interface\\Timer\\Horde-Logo.blp")
end

--Creating the background image for the frames, bg file is the background file it will call from
--edgefile is the border file it will call from, tile is whether the bg image is tiled or stretched out
--edge size is the size of the edge, basicall border thickness
--insets is think the dimensions in which the background will draw by. Idea is take edge size and divide by 4 for each.
function warTrackFrameSet()
warTrackFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
warTrackFrame:SetBackdropColor(warFrameR, warFrameG, warFrameB, warFrameTransparency);
warTrackFrame:SetBackdropBorderColor(1, 1, 1)

warFutureRankFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
warFutureRankFrame:SetBackdropColor(warFrameR, warFrameG, warFrameB, warFrameTransparency);
warFutureRankFrame:SetBackdropBorderColor(1, 1, 1)

warCurrRankFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
warCurrRankFrame:SetBackdropColor(warFrameR, warFrameG, warFrameB, warFrameTransparency);
warCurrRankFrame:SetBackdropBorderColor(1, 1, 1)

warPlayerKillFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
  warPlayerKillFrame:SetBackdropColor(warFrameR, warFrameG, warFrameB, warFrameTransparency);
  warPlayerKillFrame:SetBackdropBorderColor(1, 1, 1)

end

--text for honor level
local warHonorLvlText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warHonorLvlText:SetPoint("CENTER", warFactBanner, "TOP", 0, -8)


--text for number of current kills
local warEnemiesText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warEnemiesText:SetPoint("TOP", warTrackFrame, "TOP", 25, -5)

--text for tracking killing blows
local warTotalKillingBlowsText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warTotalKillingBlowsText:SetPoint("CENTER", warEnemiesText, "TOP", 3, -21)

--text for the last kill streak
local warLastText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warLastText:SetPoint("CENTER", warTotalKillingBlowsText, "TOP", 0, -21)

--text for highest number of kills
local highestEnemiesText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
highestEnemiesText:SetPoint("CENTER", warLastText, "TOP", 1, -21)

local totalDishonorText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
if (totalDishonorKills <= 1000) then
totalDishonorText:SetPoint("CENTER", highestEnemiesText, "TOP", 0, -21)
else
	if (totalDishonorKills <= 10000) then
	totalDishonorText:SetPoint("CENTER", highestEnemiesText, "TOP", -2, -21)
	else
	totalDishonorText:SetPoint("CENTER", highestEnemiesText, "TOP", -8, -21)
	end
end

--text for total number of kills on a character, adjusts the position based on the number for fitting purposes
local totalEnemiesText = warTrackFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
if (totalWarKills <= 1000) then
totalEnemiesText:SetPoint("CENTER", highestEnemiesText, "TOP", 0, -38)
else
	if (totalWarKills <= 10000) then
	totalEnemiesText:SetPoint("CENTER", highestEnemiesText, "TOP", -2, -38)
	else
	totalEnemiesText:SetPoint("CENTER", highestEnemiesText, "TOP", -8, -38)
	end
end

--text for current rank tracking
local currentRankTitle = warCurrRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
currentRankTitle:SetPoint("CENTER", warCurrRankFrame, "TOP", 0, -10)

--text for Highest rank tracking
local highestRankTitle = warCurrRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
highestRankTitle:SetPoint("CENTER", currentRankTitle, "TOP", 0, -20)

local warFutureTitleText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warFutureTitleText:SetPoint("CENTER", warFutureRankFrame, "TOP", 0, -8)
warFutureTitleText:SetText("Current Rank Progress Calculations")

--text for daily honor text
local warDayHonorGainedText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warDayHonorGainedText:SetPoint("CENTER", warFutureTitleText, "TOP", 0, -19)

--text for honor required for next level
local warRequireHonorText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warRequireHonorText:SetPoint("CENTER", warDayHonorGainedText, "TOP", 0, -19)

--text for honor precent to next level
local warDecayText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warDecayText:SetPoint("CENTER", warRequireHonorText, "TOP", 0, -19)

--text for honor precent to next level
local warHonorPercentText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warHonorPercentText:SetPoint("CENTER", warDecayText, "TOP", 0, -19)

local warHonorPercentDecayText = warFutureRankFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
warHonorPercentDecayText:SetPoint("CENTER", warHonorPercentText, "TOP", 0, -19)

--positions the faction banner within the frame
warFactBanner:SetPoint("LEFT", warTrackFrame, "LEFT", -15, -5)
warFactBanner:SetWidth(100)
warFactBanner:SetHeight(100)

--sets the intiial point for warTrackFrame
warTrackFrame:SetPoint("CENTER", WarGhostFrame, "CENTER", 0, 0);
warTrackFrame:Show()

--function for specifying whether the war frame is hidden or shown
function showWarFrame(frameState)
	if (frameState == true) then
	warTrackFrame:SetShown(true)
	else
	warTrackFrame:SetShown(false)
	end
end

function showCurrRankFrame(frameState)
	if (frameState == true) then
	warCurrRankFrame:Show()
	else
	warCurrRankFrame:Hide()
	end
end

function showFutureRankFrame(frameState)
	if (frameState == true) then
	warFutureRankFrame:Show()
	else
	warFutureRankFrame:Hide()
	end
end

function showPlayerKillFrame(frameState)
  if (frameState == true) then
	warPlayerKillFrame:Show()
	else
	warPlayerKillFrame:Hide()
	end
end
--function for specifying whether the faction banner is hidden or shown
function showWarLogo(warLogoState)
	if (warLogoState == true) then
	warFactBanner:Show()
	else
	warFactBanner:Hide()
	end
end

--function for specifying whether the player pvp level is hidden or shown
function showWarPvPLevel(pvpLvlState)
	if (pvpLvlState == true) then
	warHonorLvlText:Show()
	else
	warHonorLvlText:Hide()
	end
end

--function for specifying whether the current enemy kill count is hidden or shown
function showWarCurrKill(currKillState)
	if (currKillState == true) then
	warEnemiesText:Show()
	else
	warEnemiesText:Hide()
	end
end

--function for specifying whether the last kill streak is hidden or shown
function showWarLastKill(lastKillState)
	if (lastKillState == true) then
	warLastText:Show()
	else
	warLastText:Hide()
	end
end

--function for specifying whether the highest kill streak is hidden or shown
function showWarHighestKill(highestKillState)
	if (highestKillState == true) then
	highestEnemiesText:Show()
	else
	highestEnemiesText:Hide()
	end
end


--function for specifying whether the total kill count is hidden or shown
function showWarTotalKill(totalKillState)
	if (totalKillState == true) then
	totalEnemiesText:Show()
	else
	totalEnemiesText:Hide()
	end
end

--function for specifying whether the total kill count is hidden or shown
function showWarTotalDishonorKill(DishonorState)
	if (DishonorState == true) then
	totalDishonorText:Show()
	else
	totalDishonorText:Hide()
	end
end

function showWarKillsFrame(showkills)
  if(showkills == true) then
    warPlayerKillFrame:Show()
  else
    warPlayerKillFrame:Hide()
  end
end

--function for specifying whether the main frame is movable or not. is hidden or shown
function showLockFrameState(lockState)
	if (lockState == false) then
	WarGhostFrame:EnableMouse(true)
  warFutureRankFrame:EnableMouse(true)
	warCurrRankFrame:EnableMouse(true)
  warPlayerKillFrame:EnableMouse(true)
	else
	WarGhostFrame:EnableMouse(false)
  warFutureRankFrame:EnableMouse(false)
	warCurrRankFrame:EnableMouse(false)
  warPlayerKillFrame:EnableMouse(false)
	end
end

function showWarKillingblow(killingState)
	if (killingState == true) then
	warTotalKillingBlowsText:Show()
	else
	warTotalKillingBlowsText:Hide()
  end
end

--Function for setting the text color in the War Tracker panel
function setWarTextColor()
warEnemiesText:SetTextColor(warTextR, warTextG, warTextB)
warTotalKillingBlowsText:SetTextColor(warTextR, warTextG, warTextB)
warLastText:SetTextColor(warTextR, warTextG, warTextB)
highestEnemiesText:SetTextColor(warTextR, warTextG, warTextB)
totalEnemiesText:SetTextColor(warTextR, warTextG, warTextB)
totalDishonorText:SetTextColor(warTextR, warTextG, warTextB)
warHonorLvlText:SetTextColor(warTextR, warTextG, warTextB)

currentRankTitle:SetTextColor(warTextR, warTextG, warTextB)
highestRankTitle:SetTextColor(warTextR, warTextG, warTextB)

warSlainEnemiesText:SetTextColor(warTextR, warTextG, warTextB)
warSlainTitleText:SetTextColor(warTextR, warTextG, warTextB)

warFutureTitleText:SetTextColor(warTextR, warTextG, warTextB)
warDayHonorGainedText:SetTextColor(warTextR, warTextG, warTextB)
warRequireHonorText:SetTextColor(warTextR, warTextG, warTextB)
warDecayText:SetTextColor(warTextR, warTextG, warTextB)
warHonorPercentText:SetTextColor(warTextR, warTextG, warTextB)
warHonorPercentDecayText:SetTextColor(warTextR, warTextG, warTextB)
end

--Function for setting up the text for the War Tracker panel, if there are no war bounties sets active bounties to 0, else gets num active bounties based on the list of names
--also sets the text to the list string
function setWarTrackText()
  totalEnemiesText:SetText("Total Honor Kills: " .. totalWarKills)
  totalDishonorText:SetText("Total Dishonorable Kills: " .. totalDishonorKills)
  highestEnemiesText:SetText("Highest Streak: " .. highestWarKills)
  warLastText:SetText("Last Kill Streak: " .. lastWarKills)
  warEnemiesText:SetText("Enemies Slain: " .. warKills)
  warHonorLvlText:SetText("Rank: " .. currRankNumber)
  warTotalKillingBlowsText:SetText("Killing Blows: " .. totalWarKillingBlows)

  GetPlayerPvPStatInfo()
  currentRankTitle:SetText("Current Rank: " .. currRankName)
  highestRankTitle:SetText("Highest Rank: " .. highestRankName)
  AdjustCurrRankFramePos()

  CalculateFutureRankInfo()
  if(currRankNumber == 0) then
    warDayHonorGainedText:SetText("Total Honor Kills Today: " .. warTodayHonor)
  else
    warDayHonorGainedText:SetText("Total Honor This Week: " .. warWeekHonor)
  end
  warRequireHonorText:SetText("Rating Progress: " .. warRequiredHonor)
  warDecayText:SetText("Estimated Rating Decay: " .. warDecayRating)
  warHonorPercentText:SetText("Percent Complete Pre-Decay: " .. warHonorPercent.. "%")
  warHonorPercentDecayText:SetText("Percent Complete Post-Decay: " .. warHonorDecayPercent.. "%")

  warFrameRBox:SetText(warFrameR * 100)
  warFrameBBox:SetText(warFrameB * 100)
  warFrameGBox:SetText(warFrameG * 100)
  warFrameABox:SetText(warFrameTransparency * 100)
end

function setWarButtonChecks()
	--Sets the checked status of the buttons based on the saved variab;es
	warTrackFrameButton:SetChecked(warShowStates.warFrameState)
  warCurrRankButton:SetChecked(warCurrRankState)
  warFutureRankButton:SetChecked(warFutureRankState)
	lockWarFrameButton:SetChecked(warShowStates.lockFrameState)
	logoWarFrameButton:SetChecked(warShowStates.logoState)
	warKillsButton:SetChecked(warShowStates.currKillState)
	lastKillsButton:SetChecked(warShowStates.lastKillState)
	highestKillsButton:SetChecked(warShowStates.highestWarKillState)
	totalKillsButton:SetChecked(warShowStates.totalKillState)
	totalDishonorButton:SetChecked(totalDishonorState)
	pvpWarLvlButton:SetChecked(warShowStates.warPvPState)
	HideWarCombatButton:SetChecked(warHideCombatState)
	HideWarPvPButton:SetChecked(warHidePvPState)
	enableWarKillingblowsButton:SetChecked(killingBlowState)

	warResetDeathButton:SetChecked(killingBlowResetDeath)
	warResetOnZoneButton:SetChecked(killingBlowResetZone)
	warResetOnLoadButton:SetChecked(killingBlowResetLoad)
	if(killingBlowResetDeath == false and killingBlowResetLoad == false and killingBlowResetZone == false) then
		warNeverResetButton:SetChecked(true)
	end

  showKillTrackerButton:SetChecked(warPlayerKillTracker)
  trackNameHKButton:SetChecked(warTrackHKNames)
  trackNameKBButton:SetChecked(warTrackKBNames)
end

function setWarFrameStatus()
	--Sets the buttons to display on load based on saved variab;es
	showWarFrame(warShowStates.warFrameState);
	showWarCurrKill(warShowStates.currKillState);
	showWarLastKill(warShowStates.lastKillState);
	showWarHighestKill(warShowStates.highestWarKillState);
	showWarTotalKill(warShowStates.totalKillState);
	showWarTotalDishonorKill(totalDishonorState)
	showWarLogo(warShowStates.logoState);
	showLockFrameState(warShowStates.lockFrameState)
	showWarPvPLevel(warShowStates.warPvPState)
	showWarKillingblow(killingBlowState)
  showCurrRankFrame(warCurrRankState)
  showFutureRankFrame(warFutureRankState)
  showWarKillsFrame(warPlayerKillTracker)
end

function SetWMTStatus(status)
	if(status == true or status == false or status == 1 or status == 0) then
			warShowStates.warFrameState = status
			warShowStates.currKillState = status
			warShowStates.lastKillState = status
			warShowStates.highestWarKillState = status
			warShowStates.totalKillState = status
			warShowStates.logoState = status
		  warShowStates.warPvPState = status
			killingBlowState = status
			totalDishonorState = status
      warCurrRankState = status
      warFutureRankState = status
      warPlayerKillTracker = status
		else
			print("An error occured in setting the PvPT status")
		end
end

--Creat the options panel frame
local warTrackOptions = CreateFrame("Frame")
warTrackOptions.name = addOnName
InterfaceOptions_AddCategory(warTrackOptions)

--Add the addon title to the options panel
local title = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge")
title:SetTextColor(1, 1, .20)
title:SetPoint("CENTER", 0, 250)
title:SetText(addOnName)

--------------------SETTING UP THE OPTIONS PANEL BUTTONS - Buttons for enabling and disabling the text showing in the main panel
local PvPTDisplayText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
PvPTDisplayText:SetTextColor(1, 1, 1)
PvPTDisplayText:SetPoint("TOPLEFT", 16, -54);
PvPTDisplayText:SetText("PvP Tracker Display Options")

--War Frame Button
warTrackFrameButton = CreateFrame("CheckButton", "warTrackFrameButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warTrackFrameButton:SetPoint("TOPLEFT", PvPTDisplayText, "BOTTOMLEFT", 0, -10);
warTrackFrameButton_GlobalNameText:SetText(" Display PvP Tracker Frame");
warTrackFrameButton.tooltip = "Check to enable the PvP Tracker Frame";
warTrackFrameButton:SetScript("OnClick",
  function(self)
			local checker = warTrackFrameButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.warFrameState = true;
				showWarFrame(warShowStates.warFrameState);
        AdjustCurrRankFramePos()
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.warFrameState = false;
				showWarFrame(warShowStates.warFrameState);
        AdjustCurrRankFramePos()
			end
	end);

  --War Curr Rank Tracker Button
  warCurrRankButton = CreateFrame("CheckButton", "warCurrRankButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
  warCurrRankButton:SetPoint("TOPLEFT", warTrackFrameButton, "BOTTOMLEFT", 25, -5);
  warCurrRankButton_GlobalNameText:SetText(" Display 'Current Rank' Frame");
  warCurrRankButton.tooltip = "Check to enable the Current Rank Tracker Frame";
  warCurrRankButton:SetScript("OnClick",
    function(self)
        local checker = warCurrRankButton:GetChecked()
        if checker then
          PlaySound(856) -- Check Click Sound
          warCurrRankState = true;
          showCurrRankFrame(warCurrRankState)
          AdjustCurrRankFramePos()
        else
          PlaySound(857) -- Check Unclick Sound
          warCurrRankState = false;
          showCurrRankFrame(warCurrRankState)
          AdjustCurrRankFramePos()
        end
    end);

    --War Future Rank Tracker Button
    warFutureRankButton = CreateFrame("CheckButton", "warFutureRankButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
    warFutureRankButton:SetPoint("TOPLEFT", warCurrRankButton, "BOTTOMLEFT", 0, -5);
    warFutureRankButton_GlobalNameText:SetText(" Display 'Rank Calculations' Frame");
    warFutureRankButton.tooltip = "Check to enable the Rank Calculations Tracker Frame";
    warFutureRankButton:SetScript("OnClick",
      function(self)
          local checker = warFutureRankButton:GetChecked()
          if checker then
            PlaySound(856) -- Check Click Sound
            warFutureRankState = true;
            showFutureRankFrame(warFutureRankState)
            AdjustCurrRankFramePos()
          else
            PlaySound(857) -- Check Unclick Sound
            warFutureRankState = false;
            showFutureRankFrame(warFutureRankState)
            AdjustCurrRankFramePos()
          end
      end);

local warKillBlowSetText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
warKillBlowSetText:SetTextColor(1, 1, 1)
warKillBlowSetText:SetPoint("CENTER", PvPTDisplayText, "CENTER", 360, 0);
warKillBlowSetText:SetText("Killing Blow Tracker Reset Events")

--ResetOnDeath Button
warResetDeathButton = CreateFrame("CheckButton", "warResetDeathButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warResetDeathButton:SetPoint("TOPLEFT", warKillBlowSetText , "BOTTOMLEFT", 0, -12);
warResetDeathButton_GlobalNameText:SetText(" Reset on Death");
warResetDeathButton.tooltip = "Check to have the Killing Blow Tracker reset on player death";
warResetDeathButton:SetScript("OnClick",
  function(self)
			local checker = warResetDeathButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				killingBlowResetDeath = true
				warNeverResetButton:SetChecked(false)
			else
				PlaySound(857)
				killingBlowResetDeath = false;
			end
	end);

--ResetOnZone Button
warResetOnZoneButton = CreateFrame("CheckButton", "warResetOnZoneButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warResetOnZoneButton:SetPoint("TOPLEFT", warResetDeathButton , "BOTTOMLEFT", 0, -4);
warResetOnZoneButton_GlobalNameText:SetText(" Reset on Zone Change");
warResetOnZoneButton.tooltip = "Check to have the Killing Blow Tracker reset on zone change";
warResetOnZoneButton:SetScript("OnClick",
  function(self)
			local checker = warResetOnZoneButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				killingBlowResetZone = true
				warNeverResetButton:SetChecked(false)
			else
				PlaySound(857)
				killingBlowResetZone = false
			end
	end);

--ResetOnLoad Button
warResetOnLoadButton = CreateFrame("CheckButton", "warResetOnLoadButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warResetOnLoadButton:SetPoint("TOPLEFT", warResetOnZoneButton , "BOTTOMLEFT", 0, -4);
warResetOnLoadButton_GlobalNameText:SetText(" Reset on Load Screens");
warResetOnLoadButton.tooltip = "Check to have the Killing Blow Tracker reset on load screens";
warResetOnLoadButton:SetScript("OnClick",
  function(self)
			local checker = warResetOnLoadButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				killingBlowResetLoad = true
				warNeverResetButton:SetChecked(false)
			else
				PlaySound(857)
				killingBlowResetLoad = false
			end
	end);

--NeverReset Button
warNeverResetButton = CreateFrame("CheckButton", "warNeverResetButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warNeverResetButton:SetPoint("TOPLEFT", warResetOnLoadButton, "BOTTOMLEFT", 0, -4);
warNeverResetButton_GlobalNameText:SetText(" Never Reset");
warNeverResetButton.tooltip = "Check to have the Killing Blow Tracker never reset";
warNeverResetButton:SetScript("OnClick",
  function(self)
			local checker = warNeverResetButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				killingBlowResetDeath = false;
				killingBlowResetLoad = false;
				killingBlowResetZone = false;
				warResetDeathButton:SetChecked(false)
				warResetOnLoadButton:SetChecked(false)
				warResetOnZoneButton:SetChecked(false)
			else
				PlaySound(856)
				warNeverResetButton:SetChecked(true)
			end
	end);

--lock war frame button
lockWarFrameButton = CreateFrame("CheckButton", "lockWarFrameButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
lockWarFrameButton:SetPoint("TOPLEFT", warNeverResetButton, "BOTTOMLEFT", 0, -12);
lockWarFrameButton_GlobalNameText:SetText(" Lock PvP Tracker Frames");
lockWarFrameButton.tooltip = "Check to lock the PvP Tracker Frame in place";
lockWarFrameButton:SetScript("OnClick",
  function(self)
			local checker = lockWarFrameButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.lockFrameState = true;
				showLockFrameState(warShowStates.lockFrameState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.lockFrameState = false;
				showLockFrameState(warShowStates.lockFrameState);
			end
	end);

	--Hide in Combat frame button
HideWarCombatButton = CreateFrame("CheckButton", "HideWarCombatButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
HideWarCombatButton:SetPoint("TOPLEFT", lockWarFrameButton, "BOTTOMLEFT", 0, -12);
HideWarCombatButton_GlobalNameText:SetText(" Hide Frames in Combat");
HideWarCombatButton.tooltip = "Check to hide the PvP Tracker Frames when in combat";
HideWarCombatButton:SetScript("OnClick",
  function(self)
			local checker = HideWarCombatButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warHideCombatState = true
			else
				PlaySound(857) -- Check Unclick Sound
				warHideCombatState = false
			end
	end);

	--Hide when not in PvP Mode frame button
HideWarPvPButton = CreateFrame("CheckButton", "HideWarPvPButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
HideWarPvPButton:SetPoint("TOPLEFT", HideWarCombatButton, "BOTTOMLEFT", 0, -12);
HideWarPvPButton_GlobalNameText:SetText(" Hide Frames When Not Flagged for PvP");
HideWarPvPButton.tooltip = "Check to hide the PvP Tracker Frame when not flagged for PvP";
HideWarPvPButton:SetScript("OnClick",
  function(self)
			local checker = HideWarPvPButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warHidePvPState = true
				--placing it here to see what happens
				if(warHidePvPState == true) then
					if (UnitIsPVP("player") == false) then
						WarGhostFrame:Hide()
						if (warTrackFrame:IsShown() == true) then
							warTrackFrame:Hide()
						end
            if(warFutureRankFrame:IsShown() == true) then
							warFutureRankFrame:Hide()
						end
						if(warCurrRankFrame:IsShown() == true)then
							warCurrRankFrame:Hide();
						end
            if(warPlayerKillFrame:IsShown() == true) then
              warPlayerKillFrame:Hide()
            end
					end
				end
			else
				PlaySound(857) -- Check Unclick Sound
				warHidePvPState = false

				--placing it here to see what happens
				if(warHidePvPState == false) then
					WarGhostFrame:Show()
						if (warTrackFrame:IsShown() == false) then
							warTrackFrame:Show()
						end
            if(warFutureRankFrame:IsShown() == false) then
							warFutureRankFrame:Show()
						end
						if(warCurrRankFrame:IsShown() == false) then
							warCurrRankFrame:Show()
						end
            if(warPlayerKillFrame:IsShown() == false) then
              warPlayerKillFrame:Show()
            end
					end
				end
	end);

--faction banner war frame button
logoWarFrameButton = CreateFrame("CheckButton", "logoWarFrameButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
logoWarFrameButton:SetPoint("TOPLEFT", warFutureRankButton, "BOTTOMLEFT", -25, -12)
logoWarFrameButton_GlobalNameText:SetText(" Enable Faction Logo");
logoWarFrameButton.tooltip = "Check to enable your Faction's logo";
logoWarFrameButton:SetScript("OnClick",
  function(self)
			local checker = logoWarFrameButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.logoState = true;
				showWarLogo(warShowStates.logoState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.logoState = false;
				showWarLogo(warShowStates.logoState);
			end
	end);

	--Enable killing blows
enableWarKillingblowsButton = CreateFrame("CheckButton", "enableWarKillingblowsButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
enableWarKillingblowsButton:SetPoint("TOPLEFT", logoWarFrameButton, "BOTTOMLEFT", 0, -12);
enableWarKillingblowsButton_GlobalNameText:SetText(" Display Killing Blows");
enableWarKillingblowsButton.tooltip = "Check to enable the Killing Blows tracker";
enableWarKillingblowsButton:SetScript("OnClick",
  function(self)
			local checker = enableWarKillingblowsButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				killingBlowState = true
				showWarKillingblow(killingBlowState)
			else
				PlaySound(857) -- Check Unclick Sound
				killingBlowState = false
				showWarKillingblow(killingBlowState)
			end
	end);

--pvp lvl frame button
pvpWarLvlButton = CreateFrame("CheckButton", "pvpWarLvlButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
pvpWarLvlButton:SetPoint("TOPLEFT", enableWarKillingblowsButton, "BOTTOMLEFT", 0, -12);
pvpWarLvlButton_GlobalNameText:SetText(" Display Honor Level");
pvpWarLvlButton.tooltip = "Check to display your Honor Level";
pvpWarLvlButton:SetScript("OnClick",
  function(self)
			local checker = pvpWarLvlButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.warPvPState = true;
				showWarPvPLevel(warShowStates.warPvPState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.warPvPState = false;
				showWarPvPLevel(warShowStates.warPvPState);
			end
	end);

--Current Kills Button
warKillsButton = CreateFrame("CheckButton", "warKillsButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
warKillsButton:SetPoint("TOPLEFT", pvpWarLvlButton, "BOTTOMLEFT", 0, -12);
warKillsButton_GlobalNameText:SetText(" Display Enemies Slain");
warKillsButton.tooltip = "Check to enable the Enemies Slain tracker";
warKillsButton:SetScript("OnClick",
  function(self)
			local checker = warKillsButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.currKillState = true;
				showWarCurrKill(warShowStates.currKillState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.currKillState = false;
				showWarCurrKill(warShowStates.currKillState);
			end
	end);

--Last Kills Button
lastKillsButton = CreateFrame("CheckButton", "lastKillsButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
lastKillsButton:SetPoint("TOPLEFT", warKillsButton, "BOTTOMLEFT", 0, -12);
lastKillsButton_GlobalNameText:SetText(" Display Last Kill Streak");
lastKillsButton.tooltip = "Check to enable the Last Kill Streak tracker";
lastKillsButton:SetScript("OnClick",
  function(self)
			local checker = lastKillsButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.lastKillState = true;
				showWarLastKill(warShowStates.lastKillState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.lastKillState = false;
				showWarLastKill(warShowStates.lastKillState);
			end
	end);

--Highest Kills button
highestKillsButton = CreateFrame("CheckButton", "highestKillsButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
highestKillsButton:SetPoint("TOPLEFT", lastKillsButton, "BOTTOMLEFT", 0, -12);
highestKillsButton_GlobalNameText:SetText(" Display Highest Kill Streak");
highestKillsButton.tooltip = "Check to enable the Highest Kill Streak tracker";
highestKillsButton:SetScript("OnClick",
  function(self)
			local checker = highestKillsButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.highestWarKillState = true;
				showWarHighestKill(warShowStates.highestWarKillState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.highestWarKillState = false;
				showWarHighestKill(warShowStates.highestWarKillState);
			end
	end);

	--total dishonors button
	totalDishonorButton = CreateFrame("CheckButton", "totalDishonorButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
	totalDishonorButton:SetPoint("TOPLEFT", highestKillsButton, "BOTTOMLEFT", 0, -12);
	totalDishonorButton_GlobalNameText:SetText(" Display Total Character Dishonorable Kills");
	totalDishonorButton.tooltip = "Check to enable the Total Character Dishonorable Kills tracker";
	totalDishonorButton:SetScript("OnClick",
	  function(self)
				local checker = totalDishonorButton:GetChecked()
				if checker then
					PlaySound(856) -- Check Click Sound
					totalDishonorState = true;
					showWarTotalDishonorKill(totalDishonorState);
				else
					PlaySound(857) -- Check Unclick Sound
					totalDishonorState = false;
					showWarTotalDishonorKill(totalDishonorState);
				end
		end);

--total kills button
totalKillsButton = CreateFrame("CheckButton", "totalKillsButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
totalKillsButton:SetPoint("TOPLEFT", totalDishonorButton, "BOTTOMLEFT", 0, -12);
totalKillsButton_GlobalNameText:SetText(" Display Total Character PvP Kills");
totalKillsButton.tooltip = "Check to enable the Total Character PvP Kills tracker";
totalKillsButton:SetScript("OnClick",
  function(self)
			local checker = totalKillsButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warShowStates.totalKillState = true;
				showWarTotalKill(warShowStates.totalKillState);
			else
				PlaySound(857) -- Check Unclick Sound
				warShowStates.totalKillState = false;
				showWarTotalKill(warShowStates.totalKillState);
			end
	end);


--Text for the options panel that displays the RGB specifications for the panel text color
local rgbWarText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
rgbWarText:SetTextColor(1, 1, 1)
rgbWarText:SetPoint("LEFT", totalKillsButton, "RIGHT", -12, -50)
rgbWarText:SetText("Panel Text Color (RGB)")
--Text for the options panel that displays the RGBA specifications for the panel BACKGROUND
local warFrameRGBAText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
warFrameRGBAText:SetTextColor(1, 1, 1)
warFrameRGBAText:SetPoint("LEFT", rgbWarText, "RIGHT", 70, 0)
warFrameRGBAText:SetText("Panel Background Color (RGBA)")

--------------------SETTING UP THE SCALE SLIDER--------------------------------------------------

--Create text for the slider
local wmtScaleText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
wmtScaleText:SetPoint("BOTTOMLEFT", 255, 240)
wmtScaleText:SetText("Tracker Frame Scale: ")

--Creating the Slider for the wmtScaleSlider
wmtScaleSlider = CreateFrame("Slider", "wmtScaleSliderGlobalName", warTrackOptions, "OptionsSliderTemplate")
wmtScaleSlider:SetWidth(125)
wmtScaleSlider:SetHeight(15)
wmtScaleSlider:SetOrientation('HORIZONTAL')
wmtScaleSlider:SetPoint("CENTER", wmtScaleText, 125, 0);
wmtScaleSlider.tooltipText = 'Set the scale for the WMT frames' --Creates a tooltip on mouseover.
getglobal(wmtScaleSlider:GetName() .. 'Low'):SetText('.5'); --Sets the left-side slider text
getglobal(wmtScaleSlider:GetName() .. 'High'):SetText('2'); --Sets the right-side slider text
wmtScaleSlider:SetValueStep(.01)
wmtScaleSlider:SetMinMaxValues(.5, 2)
wmtScaleSlider:SetObeyStepOnDrag(obeyStep)
wmtScaleSlider:SetValue(wmtFrameScale)

--Creating editbox to show number for the slider
wmtScaleEditbox = CreateFrame("EditBox", "wmtScaleEditBoxGlobalName", warTrackOptions, "InputBoxTemplate")
wmtScaleEditbox:ClearAllPoints()
wmtScaleEditbox:ClearFocus()
wmtScaleEditbox:SetSize(70, 30)
wmtScaleEditbox:SetPoint("LEFT", wmtScaleSlider, "RIGHT", 15, 0)
wmtScaleEditbox:SetText(wmtScaleSlider:GetValue())
wmtScaleEditbox:SetAutoFocus(false)
wmtScaleEditbox:SetCursorPosition(0)

--Scripts for changing the Slider Values and text box values

--Slider <- Edit Box
wmtScaleSlider:SetScript("OnValueChanged", function(self, value)
wmtFrameScale = value;
warTrackGhost:SetScale(value)
warCurrRankFrame:SetScale(value)
warFutureRankFrame:SetScale(value)
warPlayerKillFrame:SetScale(value)
wmtScaleEditbox:SetText(string.sub(value, 1, 4))
end)

--Edit Box -> Slider
wmtScaleEditbox:SetScript("OnEnterPressed", function(self)
local val = self:GetText()
if tonumber(val) then
sliderMin, sliderMax = wmtScaleSlider:GetMinMaxValues()
	if (tonumber(val) >= sliderMin and tonumber(val) <= sliderMax) then
		wmtFrameScale = val;
		wmtScaleSlider:SetValue(wmtFrameScale)
		self:ClearFocus()
	end
else
	self:ClearFocus()
end
end)

--UI OPTIONS FOR THE PLAYER KILL TRACKER FRAME
killTrackerOptionsText = warTrackOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
killTrackerOptionsText:SetTextColor(1,1,1)
killTrackerOptionsText:SetPoint("CENTER", wmtScaleSlider, -25, -30)
killTrackerOptionsText:SetText("Slain Enemies Options")

showKillTrackerButton = CreateFrame("CheckButton", "showKillTrackerButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
showKillTrackerButton:SetPoint("TOPLEFT", killTrackerOptionsText, "BOTTOMLEFT", 0, -10);
showKillTrackerButton_GlobalNameText:SetText(" Display Slain Enemies Tracker Frame");
showKillTrackerButton.tooltip = "Check to enable the Slain Enemies Tracker Frame";
showKillTrackerButton:SetScript("OnClick",
  function(self)
			local checker = showKillTrackerButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				warPlayerKillTracker = true
        showPlayerKillFrame(warPlayerKillTracker)
			else
				PlaySound(857)
				warPlayerKillTracker = false
        showPlayerKillFrame(warPlayerKillTracker)
			end
	end);

--button for tracking the names of killing blow enemies
  trackNameKBButton = CreateFrame("CheckButton", "trackNameKBButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");
  trackNameHKButton = CreateFrame("CheckButton", "trackNameHKButton_GlobalName", warTrackOptions, "ChatConfigCheckButtonTemplate");

  trackNameKBButton:SetPoint("TOPLEFT", showKillTrackerButton, "BOTTOMLEFT", 0, -10);
  trackNameKBButton_GlobalNameText:SetText(" Track Names of Killing Blow Targets");
  trackNameKBButton.tooltip = "Check to track the names of Killing Blow targets";
  trackNameKBButton:SetChecked(warTrackKBNames);
  trackNameKBButton:SetScript("OnClick",
    function(self)
  			local checker = trackNameKBButton:GetChecked()
  			if checker then
  				PlaySound(856) -- Check Click Sound
  				warTrackKBNames = true;
          warTrackHKNames = false;
          trackNameHKButton:SetChecked(warTrackHKNames)
  			else
  				PlaySound(857)
  				warTrackKBNames = false;
          warTrackHKNames = true;
          trackNameHKButton:SetChecked(warTrackHKNames)
  			end
  	end);
--button for tracking the names of all honor killed enemies
    trackNameHKButton:SetPoint("TOPLEFT", trackNameKBButton, "BOTTOMLEFT", 0, -10);
    trackNameHKButton_GlobalNameText:SetText(" Track Names of Honorable Kill Targets");
    trackNameHKButton.tooltip = "Check to track the names of Honorable Kill targets (not colorized by class)";
    trackNameHKButton:SetChecked(warTrackHKNames);
    trackNameHKButton:SetScript("OnClick",
      function(self)
    			local checker = trackNameHKButton:GetChecked()
    			if checker then
    				PlaySound(856) -- Check Click Sound
            warTrackKBNames = false;
            warTrackHKNames = true;
            trackNameKBButton:SetChecked(warTrackKBNames)
    			else
    				PlaySound(857)
            warTrackKBNames = true;
            warTrackHKNames = false;
            trackNameKBButton:SetChecked(warTrackKBNames)
    			end
    	end);
--warPlayerKillTracker

--------------------SETTING RBG Button Edit Boxes ------------------------------------------------
--Creating editbox for the red RBG text value
 redWarBox = CreateFrame("EditBox", "Red Box", warTrackOptions, "InputBoxTemplate")
 redWarBox:SetNumeric()
 redWarBox:ClearAllPoints()
 redWarBox:ClearFocus()
 redWarBox:SetSize(30, 30)
 redWarBox:SetPoint("LEFT", totalKillsButton, "RIGHT", -15, -85)
 redWarBox:SetText(warTextR * 100)
 redWarBox:SetAutoFocus(false)
 redWarBox:SetCursorPosition(0)

 --Editbox script Red
 redWarBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warTextR = (val / 100);
		setWarTextColor()
		self:ClearFocus()
	else
	warTextR = 100;
	setWarTextColor()
	self:SetText(100)
	end
end)

--Green color value edit box setup
 greenWarBox = CreateFrame("EditBox", "Green Box", warTrackOptions, "InputBoxTemplate")
 greenWarBox:SetNumeric()
 greenWarBox:ClearAllPoints()
 greenWarBox:ClearFocus()
 greenWarBox:SetSize(30, 30)
 greenWarBox:SetPoint("CENTER", redWarBox, "RIGHT", 45, 0)
 greenWarBox:SetText(warTextG * 100)
 greenWarBox:SetAutoFocus(false)
 greenWarBox:SetCursorPosition(0)

 --Editbox script Green
 greenWarBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warTextG = (val / 100);
		setWarTextColor()
		self:ClearFocus()
	else
	warTextG = 100;
	setWarTextColor()
	self:SetNumber(100)
	end
end)

--Blue color value edit box setup
 blueWarBox = CreateFrame("EditBox", "Blue Box", warTrackOptions, "InputBoxTemplate")
 blueWarBox:SetNumeric()
 blueWarBox:ClearAllPoints()
 blueWarBox:ClearFocus()
 blueWarBox:SetSize(30, 30)
 blueWarBox:SetPoint("CENTER", greenWarBox, "RIGHT", 45, 0)
 blueWarBox:SetText(warTextB * 100)
 blueWarBox:SetAutoFocus(false)
 blueWarBox:SetCursorPosition(0)

 --Editbox script Blue
 blueWarBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warTextB = (val / 100);
		setWarTextColor()
		self:ClearFocus()
	else
	warTextB = 100;
	setWarTextColor()
	self:SetNumber(100)
	end
end)


--Frame Red  value edit box setup
 warFrameRBox = CreateFrame("EditBox", "Warframe Red Box", warTrackOptions, "InputBoxTemplate")
 warFrameRBox:SetNumeric()
 warFrameRBox:ClearAllPoints()
 warFrameRBox:ClearFocus()
 warFrameRBox:SetSize(30, 30)
 warFrameRBox:SetPoint("CENTER", blueWarBox, "RIGHT", 85, 0)
 warFrameRBox:SetText(warFrameR * 100)
 warFrameRBox:SetAutoFocus(false)
 warFrameRBox:SetCursorPosition(0)

 --Editbox script Frame Red
 warFrameRBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warFrameR = (val / 100);
		warTrackFrameSet()
		self:ClearFocus()
	else
	warFrameR = (100 / 10);
	warTrackFrameSet()
	self:SetNumber(100)
	end
end)

--Frame Green  value edit box setup
 warFrameGBox = CreateFrame("EditBox", "Warframe Green Box", warTrackOptions, "InputBoxTemplate")
 warFrameGBox:SetNumeric()
 warFrameGBox:ClearAllPoints()
 warFrameGBox:ClearFocus()
 warFrameGBox:SetSize(30, 30)
 warFrameGBox:SetPoint("CENTER", warFrameRBox, "RIGHT", 45, 0)
 warFrameGBox:SetText(warFrameG * 100)
 warFrameGBox:SetAutoFocus(false)
 warFrameGBox:SetCursorPosition(0)

 --Editbox script Frame Green
 warFrameGBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warFrameG = (val / 100);
		warTrackFrameSet()
		self:ClearFocus()
	else
	warFrameG = (100 / 10);
	warTrackFrameSet()
	self:SetNumber(100)
	end
end)

--Frame Blue value edit box setup
 warFrameBBox = CreateFrame("EditBox", "Warframe Blue Box", warTrackOptions, "InputBoxTemplate")
 warFrameBBox:SetNumeric()
 warFrameBBox:ClearAllPoints()
 warFrameBBox:ClearFocus()
 warFrameBBox:SetSize(30, 30)
 warFrameBBox:SetPoint("CENTER", warFrameGBox, "RIGHT", 45, 0)
 warFrameBBox:SetText(warFrameB * 100)
 warFrameBBox:SetAutoFocus(false)
 warFrameBBox:SetCursorPosition(0)

 --Editbox script Frame Blue
 warFrameBBox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warFrameB = (val / 100);
		warTrackFrameSet()
		self:ClearFocus()
	else
	warFrameB = (100 / 10);
	warTrackFrameSet()
	self:SetNumber(100)
	end
end)

--Frame Alpha value edit box setup
 warFrameABox = CreateFrame("EditBox", "Warframe Alpha Box", warTrackOptions, "InputBoxTemplate")
 warFrameABox:SetNumeric()
 warFrameABox:ClearAllPoints()
 warFrameABox:ClearFocus()
 warFrameABox:SetSize(30, 30)
 warFrameABox:SetPoint("CENTER", warFrameBBox, "RIGHT", 45, 0)
 warFrameABox:SetText(warFrameTransparency * 100)
 warFrameABox:SetAutoFocus(false)
 warFrameABox:SetCursorPosition(0)

 --Editbox script Frame Alpha
 warFrameABox:SetScript("OnEnterPressed", function(self)
	local val = self:GetNumber()
	if (val <= 100) then
		warFrameTransparency = (val / 100);
		warTrackFrameSet()
		self:ClearFocus()
	else
	warFrameTransparency = (100 / 10);
	warTrackFrameSet()
	self:SetNumber(100)
	end
end)

-------CREATING THE RESET BUTTON FOR HIGHEST SCORE
local resetWarHighest = CreateFrame("Button", "Reset Highest Streak", warTrackOptions)
resetWarHighest:SetPoint("LEFT", redWarBox, "CENTER", -25, -28)
resetWarHighest:SetWidth(175)
resetWarHighest:SetHeight(25)
resetWarHighest:SetText("RESET HIGHEST STREAK")
resetWarHighest:SetNormalFontObject("GameFontNormal")

--Setting the background for the reset button
resetWarHighest:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 16,
	insets = {left = 2, right = 2, top = 4.5, bottom = 4.5}});
resetWarHighest:SetBackdropColor(.75, 0, .25);
resetWarHighest:SetBackdropBorderColor(1, 1, 1)

--Script for the reset button
resetWarHighest:SetScript("OnClick", function(self)
	highestWarKills = 0;
	highestEnemiesText:SetText("Highest Streak: " .. highestWarKills)
end)

--Script for the "Okay" button in the options menu, makes it so all edit boxes confirm and submit whats entered in them upon button press
warTrackOptions.okay = function(self)
	local redWarVal = redWarBox:GetText()
	warTextR = (redWarVal / 100);
	redWarBox:ClearFocus()

	local greenWarVal = greenWarBox:GetText()
	warTextG = (greenWarVal / 100);
	greenWarBox:ClearFocus()

	local blueWarVal = blueWarBox:GetText()
	warTextB = (blueWarVal / 100);
	blueWarBox:ClearFocus()

	local blueWarVal = blueWarBox:GetText()
	warTextB = (blueWarVal / 100);
	blueWarBox:ClearFocus()

	local warFrameRVal = warFrameRBox:GetText()
	warFrameR = (warFrameRVal / 100);
	warFrameRBox:ClearFocus()

	local warFrameGVal = warFrameGBox:GetText()
	warFrameG = (warFrameGVal / 100);
	warFrameGBox:ClearFocus()

	local warFrameBVal = warFrameBBox:GetText()
	warFrameB = (warFrameBVal / 100);
	warFrameBBox:ClearFocus()

	local warFrameAVal = warFrameABox:GetText()
	warFrameTransparency = (warFrameAVal / 100);
	warFrameABox:ClearFocus()

	warTrackFrameSet()
	setWarTextColor()
end

--SLASH COMMANDS
local function WMTSlashCommands(cmd, editbox)
	if(cmd == "nil" or cmd == "" or cmd == " ") then
		print("|cffff0000PvP Tracker Commands:|r")
		print("|cffffff00 -'/pvpt ON' - Turns on all features of PvP Tracker|r")
		print("|cffffff00 -'/pvpt OFF' - Turns off all features of PvP Tracker|r")
		print("|cffffff00 -'/pvpt LOCK' - Locks/Unlocks the PvP Tracker frame|r")
		print("|cffffff00 -'/pvpt HIDE IN COMBAT' - Toggles the Hide in Combat mode On/Off for the PvP Tracker frame |r")
		print("|cffffff00 -'/pvpt HIDE IN PVE' - Toggles the Hide in PvE mode On/Off for the PvP Tracker frame  |r")
		print("|cffffff00 -'/pvpt MAIN FRAME' - Toggles the PvP Tracker frame On/Off |r")
    print("|cffffff00 -'/pvpt RANK FRAME' - Toggles the PvP Tracker frame On/Off |r")
    print("|cffffff00 -'/pvpt CALC FRAME' - Toggles the PvP Tracker frame On/Off |r")
    print("|cffffff00 -'/pvpt KILLS FRAME' - Toggles the Enemies Slain frame On/Off |r")
    print("|cffffff00 -'/pvpt KILLS HK' - Toggles the Enemies Slain Frame to track Honorable Kills |r")
    print("|cffffff00 -'/pvpt KILLS KB' - Toggles the Enemies Slain Frame to track Killing Blows |r")
    print("|cffffff00 -'/pvpt CLEAR KILLS' - Clears the Slain Enemies list |r")
		print("|cffffff00For a full list of the Settings, go to 'Interface -> Addons -> PvP Tracker' !|r")
	end
	if (string.lower(cmd) == "on") then
		print("|cffffff00 PvP Tracker is now ON |r")
		SetWMTStatus(true)
		setWarFrameStatus()
		setWarButtonChecks()
    AdjustCurrRankFramePos()
	end
	if(string.lower(cmd) == "off") then
		print("|cffffff00 PvP Tracker is now OFF |r")
		SetWMTStatus(false)
		setWarFrameStatus()
		setWarButtonChecks()
    AdjustCurrRankFramePos()
	end
	if(string.lower(cmd) == "lock") then
		if (warShowStates.lockFrameState == true) then
			print("|cffffff00 PvP Tracker Lock Status: UNLOCKED |r")
			warShowStates.lockFrameState = false
		else
			print("|cffffff00 PvP Tracker Lock Status: LOCKED |r")
			warShowStates.lockFrameState = true
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
	if(string.lower(cmd) == "hide in combat") then
		if(warHideCombatState == false) then
			print("|cffffff00 PvP Tracker Hide in Combat Status: ACTIVE |r")
			warHideCombatState = true
		else
			print("|cffffff00 PvP Tracker Hide in Combat Status: INACTIVE |r")
			warHideCombatState = false
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
	if(string.lower(cmd) == "hide in pve") then
		if(warHidePvPState == false) then
			print("|cffffff00 PvP Tracker Hide in PvE Status: ACTIVE |r")
			warHidePvPState = true
		else
			print("|cffffff00 PvP Tracker Hide in PvE Status: INACTIVE |r")
			warHidePvPState = false
			WarGhostFrame:Show()
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
	if(string.lower(cmd) == "main frame") then
		if(warShowStates.warFrameState == true) then
			print("|cffffff00 PvP Tracker Frame Status: INACTIVE |r")
			warShowStates.warFrameState = false
		else
			print("|cffffff00 PvP Tracker Frame Status: ACTIVE |r")
			warShowStates.warFrameState = true
		end
		setWarFrameStatus()
		setWarButtonChecks()
    AdjustCurrRankFramePos()
	end
  if(string.lower(cmd) == "rank frame") then
		if(warCurrRankState == true) then
			print("|cffffff00 Current Rank Frame Status: INACTIVE |r")
			warCurrRankState = false
		else
			print("|cffffff00 Current Rank Frame Status: ACTIVE |r")
			warCurrRankState = true
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
  if(string.lower(cmd) == "calc frame") then
		if(warFutureRankState == true) then
			print("|cffffff00 Rank Calculations Frame Status: INACTIVE |r")
			warFutureRankState = false
		else
			print("|cffffff00 Rank Calculations Frame Status: ACTIVE |r")
			warFutureRankState = true
		end
		setWarFrameStatus()
		setWarButtonChecks()
    AdjustCurrRankFramePos()
	end
  if(string.lower(cmd) == "kills frame") then
		if(warPlayerKillTracker == true) then
			print("|cffffff00 Enemies Slain Frame Status: INACTIVE |r")
			warPlayerKillTracker = false
		else
			print("|cffffff00 Enemies Slain Frame Status: ACTIVE |r")
			warPlayerKillTracker = true
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
  if(string.lower(cmd) == "kills hk") then
		if(warTrackHKNames == true) then
			print("|cffffff00 Honorable Kill Player Tracking: INACTIVE\nKilling Blow Player Tracking: ACTIVE|r")
			warTrackHKNames = false
      warTrackKBNames = true
		else
			print("|cffffff00 Honorable Kill Player Tracking: ACTIVE\nKilling Blow Player Tracking: INACTIVE|r")
			warTrackHKNames = true
      warTrackKBNames = false
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
  if(string.lower(cmd) == "kills kb") then
		if(warTrackKBNames == true) then
			print("|cffffff00 Killing Blow Player Tracking: INACTIVE\nHonorable Kill Player Tracking: ACTIVE|r")
			warTrackKBNames = false
      warTrackHKNames = true
		else
			print("|cffffff00 Killing Blow Player Tracking: ACTIVE\nHonorable Kill Player Tracking: INACTIVE|r")
			warTrackKBNames = true
      warTrackHKNames = false
		end
		setWarFrameStatus()
		setWarButtonChecks()
	end
  if(string.lower(cmd) == "clear kills") then
    wipe(playerWarKills)
    wipe(sortedWarKills)
    warPlayerKillFrame:SetWidth(150)
    warPlayerKillFrame:SetHeight(20)
    warSlainEnemiesText:SetText("")
    warClearKillButton:Hide();
	end
end
--create the PvPT slash command
SLASH_PVPT1 = '/pvpt'
-- register the wmt slash commant and call the WMTSlashCommands function
SlashCmdList["PVPT"] = WMTSlashCommands

--Script fired off during events. Primary purpose is to set variables/text
local function OnWarUpdates(_, event, arg1, arg2, arg3, arg4)
	if (event == "PLAYER_ENTERING_WORLD") then
		--get the total honor kills and pvp rank
		totalWarKills, totalDishonorKills = GetPVPLifetimeStats();
		lastTotalWarKills = GetPVPLifetimeStats();
		--Reset war kills
		if (warKills ~= 0) then
		lastWarKills = warKills
		warKills = 0;
		end
		--reset killing blows
		if(killingBlowResetLoad == true) then
			totalWarKillingBlows = 0
		end
		warLastText:SetText("Last Kill Streak: " .. lastWarKills)

    GetPlayerPvPStatInfo()
    CalculateFutureRankInfo()

		--Set the panel text
		setWarTrackText();
		--Load the text color
		setWarTextColor();
		--setup the main panel background
		warTrackFrameSet();

		--Set Editbox values for colors
		blueWarBox:SetNumber(warTextB * 100)
		greenWarBox:SetNumber(warTextG * 100)
		redWarBox:SetNumber(warTextR * 100)
		blueWarBox:SetCursorPosition(0)
		greenWarBox:SetCursorPosition(0)
		redWarBox:SetCursorPosition(0)
		warFrameRBox:SetCursorPosition(0)
		warFrameBBox:SetCursorPosition(0)
		warFrameGBox:SetCursorPosition(0)
		warFrameABox:SetCursorPosition(0)
		wmtScaleSlider:SetValue(wmtFrameScale)
		wmtScaleEditbox:SetText(string.sub(wmtFrameScale, 1, 4))
		wmtScaleEditbox:SetCursorPosition(0)

		setWarFrameStatus() -- set the show status of the frames and elements
		setWarButtonChecks() -- set the button check statuses
    AdjustCurrRankFramePos()
	end
	if (event == "PLAYER_DEAD") then
		if (highestWarKills < warKills) then
			highestWarKills = warKills
		end
		lastWarKills = warKills
		warKills = 0
		if(killingBlowResetDeath == true) then
			totalWarKillingBlows = 0
		end
		setWarTrackText()
	end
	if (event == "PLAYER_PVP_KILLS_CHANGED") then
		totalWarKills, totalDishonorKills = GetPVPLifetimeStats();
		warKills = warKills + (totalWarKills - lastTotalWarKills)
		lastTotalWarKills = totalWarKills;
		if (highestWarKills <= warKills) then
			highestWarKills = warKills
		end
    GetPlayerPvPStatInfo()
    CalculateFutureRankInfo()
		setWarTrackText()
		warTrackFrame:UnregisterEvent("PLAYER_PVP_KILLS_CHANGED");
	end


	if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
	local _,warEventType, _, sourceGUID, sourceName, _, _, destGUID, destName, _, _ = CombatLogGetCurrentEventInfo()
		if(warEventType=="PARTY_KILL") then
		local warUnitType = strsplit("-", destGUID)
		if (warUnitType == "Player" and warPlayerName == sourceName)then
				totalWarKillingBlows = totalWarKillingBlows + 1
				setWarTrackText()
			end
		end
	end

	if (event=="PLAYER_REGEN_DISABLED") then
		warCombatState = true
		if (warHideCombatState == true) then
			WarGhostFrame:Hide();
			if(warShowStates.warFrameState == true) then
				warTrackFrame:Hide()
			end
      if(warFutureRankState == true) then
				warFutureRankFrame:Hide()
			end
			if(warCurrRankState == true) then
				warCurrRankFrame:Hide()
			end
      if(warPlayerKillTracker == true) then
        warPlayerKillFrame:Hide();
      end
		end
	end
	if (event=="PLAYER_REGEN_ENABLED") then
		warCombatState = false
		WarGhostFrame:Show();
		if(warShowStates.warFrameState == true) then
				warTrackFrame:Show()
		end
    if(warFutureRankState == true) then
      warFutureRankFrame:Show()
    end
    if(warCurrRankState == true) then
      warCurrRankFrame:Show()
    end
    if(warPlayerKillTracker == true) then
      warPlayerKillFrame:Show();
    end
	end
	if(event=="ZONE_CHANGED_NEW_AREA") then
		if(killingBlowResetZone == true) then
			totalWarKillingBlows = 0
		end
		setWarTrackText()
	end
	if(event=="ZONE_CHANGED") then
		--show war track frame if its not currently showing and warhidepvpstate is false
		if(warHidePvPState == true) then
			WarGhostFrame:Show()
			if (UnitIsPVP("player") == true) then
				if (warTrackFrame:IsShown() == false) then
					warTrackFrame:Show()
				end
        if(warFutureRankFrame:IsShown() == false) then
					warFutureRankFrame:Show()
				end
				if(warCurrRankFrame:IsShown() == false) then
					warCurrRankFrame:Show()
				end
        if(warPlayerKillFrame:IsShown() == false) then
          warPlayerKillFrame:Show()
        end
			end
		end
	end
end
--registers all necessary events and sets the script
warTrackFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
warTrackFrame:RegisterEvent("PLAYER_DEAD")
warTrackFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")
warTrackFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
warTrackFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
warTrackFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
warTrackFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
warTrackFrame:RegisterEvent("ZONE_CHANGED")
warTrackFrame:SetScript("OnEvent", OnWarUpdates)

--Re register frame creation, and checks for the PVP kill event being unregistered in main frame and reregisters (avoids multi firing events)
local reReg = CreateFrame("Frame")
reReg:SetScript("OnUpdate", function(_, elapsed)
--is the pvp kills change event is not registered, re-registers it
if (warTrackFrame:IsEventRegistered("PLAYER_PVP_KILLS_CHANGED") == false) then
warTrackFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")
end

--Checks to see if warHidePvPStates is true, if it is then checks if war mode is active. If it isnt, it checks if the frames are showing, if they are hides them. This is for hiding frames when war mode is inactive
--also checks if the player is in combat or not with warCombatState which is set in the event registers section when the player enters/exists combat

if(warHidePvPState == true) then
	if (UnitIsPVP("player") == false) then
		WarGhostFrame:Hide()
		if (warTrackFrame:IsShown() == true) then
			warTrackFrame:Hide()
		end
    if(warFutureRankFrame:IsShown() == true) then
			warFutureRankFrame:Hide()
		end
		if(warCurrRankFrame:IsShown() == true) then
			warCurrRankFrame:Hide()
		end
    if(warPlayerKillFrame:IsShown() == true) then
      warPlayerKillFrame:Hide()
    end
	end
end

if (warShowStates.warFrameState == false) then
	if (warTrackFrame:IsShown() == true) then
		warTrackFrame:Hide()
	end
end

if (warFutureRankState == false) then
	if (warFutureRankFrame:IsShown() == true) then
		warFutureRankFrame:Hide()
	end
end

if (warCurrRankState == false) then
	if (warCurrRankFrame:IsShown() == true) then
		warCurrRankFrame:Hide()
	end
end

if(warPlayerKillTracker == false) then
  if(warPlayerKillFrame:IsShown() == true) then
    warPlayerKillFrame:Hide()
  end
end

--sets the never reset button to active is all other buttons are off.
	if(killingBlowResetDeath == false and killingBlowResetLoad == false and killingBlowResetZone == false) then
		warNeverResetButton:SetChecked(true)
	end
end)
